[![Vapor](https://cloud.githubusercontent.com/assets/1342803/15592871/46decfda-2375-11e6-9494-a9bf4e6aaebf.png)](http://slack.qutheory.io)

# Vapor

A Web Framework for Swift that works on iOS, OS X, and Ubuntu.

- [x] Pure Swift
- [x] Modular
- [x] Beautifully expressive

![Swift](https://camo.githubusercontent.com/0727f3687a1e263cac101c5387df41048641339c/68747470733a2f2f696d672e736869656c64732e696f2f62616467652f53776966742d332e302d6f72616e67652e7376673f7374796c653d666c6174)
[![Build Status](https://api.travis-ci.org/qutheory/vapor.svg?branch=master)](https://travis-ci.org/qutheory/vapor)
[![Slack Status](http://qutheory.io:8001/badge.svg)](http://slack.qutheory.io)
[![Twitter Follow](https://img.shields.io/twitter/follow/shields_io.svg?style=social&label=Follow&maxAge=2592000)](https://twitter.com/qutheory)
[![codebeat badge](https://codebeat.co/badges/3334c72c-c6e6-4061-a86b-f077b5250252)](https://codebeat.co/projects/github-com-qutheory-vapor)
[![PRs Welcome](https://img.shields.io/badge/prs-welcome-brightgreen.svg)](http://makeapullrequest.com)
[![OpenCollective](https://opencollective.com/vapor/backers/badge.svg)](#backers) 
[![OpenCollective](https://opencollective.com/vapor/sponsors/badge.svg)](#sponsors)

Vapor is the first true web framework for Swift. It provides a beautifully expressive and easy to use foundation for your next website or API.

This repository is the framework's source code. To view a sample project, check out the [Vapor Example](https://github.com/qutheory/vapor-example).

## 📖 Documentation

Visit the [Documentation](http://docs.qutheory.io) for extensive information on getting setup, using, and deploying Vapor.

## 🚀 Contributing

To contribute a **feature or idea** to Vapor, submit an issue and fill in the template. If the request is approved, you or one of the members of the community can start working on it.

If you find a **bug**, please submit a pull request with a failing test case displaying the bug or create an issue.

If you find a **security vulnerability**, please contact [tanner@qutheory.io](tanner@qutheory.io) as soon as possible. We take these matters seriously.

## 💙 Code of Conduct

Our goal is to create a safe and empowering environment for anyone who decides to use or contribute to Vapor. Please help us make the community a better place by abiding to this [Code of Conduct](https://github.com/qutheory/vapor/blob/master/CODE_OF_CONDUCT.md) during your interactions surrounding this project. 

## 🔧 Compatibility

Vapor has been tested on OS X 10.11, Ubuntu 14.04, and Ubuntu 15.10. 

Our homepage [http://qutheory.io](http://qutheory.io) is currently running using Vapor on DigitalOcean.

## Backers

Support us with a monthly donation and help us continue our activities. [[Become a backer](https://opencollective.com/vapor#backer)]

<a href="https://opencollective.com/vapor/backer/0/website" target="_blank"><img src="https://opencollective.com/vapor/backer/0/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/1/website" target="_blank"><img src="https://opencollective.com/vapor/backer/1/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/2/website" target="_blank"><img src="https://opencollective.com/vapor/backer/2/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/3/website" target="_blank"><img src="https://opencollective.com/vapor/backer/3/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/4/website" target="_blank"><img src="https://opencollective.com/vapor/backer/4/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/5/website" target="_blank"><img src="https://opencollective.com/vapor/backer/5/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/6/website" target="_blank"><img src="https://opencollective.com/vapor/backer/6/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/7/website" target="_blank"><img src="https://opencollective.com/vapor/backer/7/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/8/website" target="_blank"><img src="https://opencollective.com/vapor/backer/8/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/9/website" target="_blank"><img src="https://opencollective.com/vapor/backer/9/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/10/website" target="_blank"><img src="https://opencollective.com/vapor/backer/10/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/11/website" target="_blank"><img src="https://opencollective.com/vapor/backer/11/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/12/website" target="_blank"><img src="https://opencollective.com/vapor/backer/12/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/13/website" target="_blank"><img src="https://opencollective.com/vapor/backer/13/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/14/website" target="_blank"><img src="https://opencollective.com/vapor/backer/14/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/15/website" target="_blank"><img src="https://opencollective.com/vapor/backer/15/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/16/website" target="_blank"><img src="https://opencollective.com/vapor/backer/16/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/17/website" target="_blank"><img src="https://opencollective.com/vapor/backer/17/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/18/website" target="_blank"><img src="https://opencollective.com/vapor/backer/18/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/19/website" target="_blank"><img src="https://opencollective.com/vapor/backer/19/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/20/website" target="_blank"><img src="https://opencollective.com/vapor/backer/20/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/21/website" target="_blank"><img src="https://opencollective.com/vapor/backer/21/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/22/website" target="_blank"><img src="https://opencollective.com/vapor/backer/22/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/23/website" target="_blank"><img src="https://opencollective.com/vapor/backer/23/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/24/website" target="_blank"><img src="https://opencollective.com/vapor/backer/24/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/25/website" target="_blank"><img src="https://opencollective.com/vapor/backer/25/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/26/website" target="_blank"><img src="https://opencollective.com/vapor/backer/26/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/27/website" target="_blank"><img src="https://opencollective.com/vapor/backer/27/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/28/website" target="_blank"><img src="https://opencollective.com/vapor/backer/28/avatar.svg"></a>
<a href="https://opencollective.com/vapor/backer/29/website" target="_blank"><img src="https://opencollective.com/vapor/backer/29/avatar.svg"></a>


## Sponsors

Become a sponsor and get your logo on our README on Github with a link to your site. [[Become a sponsor](https://opencollective.com/vapor#sponsor)]

<a href="https://opencollective.com/vapor/sponsor/0/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/0/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/1/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/1/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/2/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/2/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/3/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/3/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/4/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/4/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/5/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/5/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/6/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/6/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/7/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/7/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/8/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/8/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/9/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/9/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/10/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/10/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/11/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/11/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/12/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/12/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/13/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/13/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/14/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/14/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/15/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/15/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/16/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/16/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/17/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/17/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/18/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/18/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/19/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/19/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/20/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/20/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/21/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/21/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/22/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/22/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/23/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/23/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/24/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/24/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/25/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/25/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/26/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/26/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/27/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/27/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/28/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/28/avatar.svg"></a>
<a href="https://opencollective.com/vapor/sponsor/29/website" target="_blank"><img src="https://opencollective.com/vapor/sponsor/29/avatar.svg"></a>

## ⚠️ Work in Progress

This is a work in progress, so *do not* rely on this for anything important. And pull requests are welcome!

## 👥 Authors

Made by [Tanner Nelson](https://twitter.com/tanner0101), [Logan Wright](https://twitter.com/logmaestro), and the hundreds of members of the Qutheory community.
